//返回设备信息
ifly_getDeviceInfo = function () {
    var resultJson = exec('com.iflytek.mmp.components.DeviceInfoComponents', 'getDeviceInfo', []);
    var device = getResultMessage(resultJson);
    return device;
}

//获取皮肤包路径
ifly_getCurrentSkinPath = function () {
    var a = exec("WidgetMMPContainerComponents", "getCurrentSkinPath", []);
    return getResultMessage(a)
}

//获取版本标识，是否为cmcc版本
ifly_getVersionFlag = function () {
    var a = exec("WidgetMMPContainerComponents", "getCmccFlag", []);
    return getResultMessage(a)
}


//与接口相关的函数
var getResultCode = function (resultJson) {
    var resultJS = convertType(resultJson);
    return resultJS.code;
}
var getResultMessage = function (resultJson) {
    var resultJS = convertType(resultJson);
    return resultJS.message;
}
var convertType = function (resultJson) {
    var resultJS = eval("(" + resultJson + ")");
    return resultJS;
}
//调用引擎的java接口
exec = function(service, action, args) {

    var result = prompt("iflytek:" + stringify([service, action]), stringify(args));

    return result;
}
//将[xxx,yyy,...]组装成json数组
stringify = function(args) {
    if( typeof JSON === "undefined") {
        var s = "[";
        var i, type, start, name, nameType, a;
        for( i = 0; i < args.length; i++) {
            if(args[i] !== null) {
                if(i > 0) {
                    s = s + ",";
                }
                type = typeof args[i];
                if((type === "number") || (type === "boolean")) {
                    s = s + args[i];
                } else if(args[i] instanceof Array) {
                    s = s + "[" + args[i] + "]";
                } else if(args[i] instanceof Object) {
                    start = true;
                    s = s + '{';
                    for(name in args[i]) {
                        if(args[i][name] !== null) {
                            if(!start) {
                                s = s + ',';
                            }
                            s = s + '"' + name + '":';
                            nameType = typeof args[i][name];
                            if((nameType === "number") || (nameType === "boolean")) {
                                s = s + args[i][name];
                            } else if(( typeof args[i][name]) === 'function') {
                                // don't copy the functions
                                s = s + '""';
                            } else if(args[i][name] instanceof Object) {
                                s = s + PhoneGap.stringify(args[i][name]);
                            } else {
                                s = s + '"' + args[i][name] + '"';
                            }
                            start = false;
                        }
                    }
                    s = s + '}';
                } else {
                    a = args[i].replace(/\\/g, '\\\\');
                    a = a.replace(/"/g, '\\"');
                    s = s + '"' + a + '"';
                }
            }
        }
        s = s + "]";
        return s;
    } else {
        return JSON.stringify(args);
    }
}
