/**
 * 音乐视图
 * 
 * @author ppfeng
 * 
 */
define(function() {
	var istouchmove = false;// 点击音乐列项时是否触发touchmove
	var oldMusicView = null; // 保存音乐view对象
	var musictaskHandler; // 保存音乐view对应的java层处理组件的标识
	var current_music_show_items = 5;// 当前显示的音乐条数，记录返回音乐的数目
	var music_view_state = "";
	var music_infomation = null;
	var mindex = 0;// 记录歌曲索引
	var counter = 0;// 记录缓冲图片在数组中的位置
	var music_buffer_state = "";// 记录正在播放的歌曲的状态，用于判断需不需要进行缓冲
	/*
	 * 创建音乐列项--联通
	 */
	function createMusicItem2(id, musicname, singer, networkType) {
		var itemDiv = document.createElement("div");
	
		itemDiv.id = id;
		itemDiv.className = "css_music_item_div";
	
		var musicnameAndsourceAndfoldstateDiv = document.createElement("div");
		musicnameAndsourceAndfoldstateDiv.style.display = "inline-block";
		musicnameAndsourceAndfoldstateDiv.className = "css_musicname_and_source_and_foldstate_div";
	
		var musicnameDiv = document.createElement("div");
		musicnameDiv.innerText = musicname;
		musicnameDiv.style.display = "inline-block";
		musicnameDiv.className = "css_musicname_div";
		musicnameDiv.id = id + "musicnameDiv";
	
		var musicbufferImg = document.createElement("img");
		musicbufferImg.className = "css_music_buffer_img";
		musicbufferImg.src = music_buffer_spot1;
	
		var musicImgdiv = document.createElement("div");
		musicImgdiv.style.display = "float:right";
		musicImgdiv.style.display = "inline-block";
		musicImgdiv.className = "css_music_img_div";
		musicImgdiv.id = id + "musicImgdiv";
	
		var sourceImg = document.createElement("img");
		if (networkType == "1") {
			sourceImg.src = music_source_net;
		} else {
			sourceImg.style.display = "none";
		}
		sourceImg.className = "css_source_img";
		sourceImg.id = id + "sourceImg";
	
		var singerDiv = document.createElement("div");
		singerDiv.innerText = singer;
		singerDiv.className = "css_singer_div";
		singerDiv.id = id + "singerDiv";
	
		musicImgdiv.appendChild(sourceImg);
	
		var playingFlag = document.createElement("div");
		playingFlag.className = "css_music_playing_flag";
	
		musicnameAndsourceAndfoldstateDiv.appendChild(musicnameDiv);
		musicnameAndsourceAndfoldstateDiv.appendChild(musicbufferImg);
		musicnameAndsourceAndfoldstateDiv.appendChild(musicImgdiv);
	
		itemDiv.appendChild(playingFlag);
		itemDiv.appendChild(musicnameAndsourceAndfoldstateDiv);
		itemDiv.appendChild(singerDiv);
		itemDiv.setAttribute("ontouchstart", "touchstart('" + id + "')");
		itemDiv.setAttribute("ontouchmove", "touchmove('" + id + "')");
		itemDiv.setAttribute("ontouchend", "touchend('" + id + "')");
	
		return itemDiv;
	}
	
	var move_music_song = false;
	var move_music_ring = false;
	var move_music_setRing = false;
	/*
	 * 创建音乐列项--移动版本
	 */
	function createMusicItem(id, musicname, singer, networkType) {
		var itemDiv = document.createElement("div");
		var idNumber = parseInt(id.charAt(5));
	
		itemDiv.id = id;
		itemDiv.className = "css_music_item_div";
	
		var musicnameAndsourceAndfoldstateDiv = document.createElement("div");
		musicnameAndsourceAndfoldstateDiv.style.display = "inline-block";
		musicnameAndsourceAndfoldstateDiv.className = "css_musicname_and_source_and_foldstate_div";
	
		var musicnameDiv = document.createElement("div");
		musicnameDiv.innerText = musicname;
		musicnameDiv.style.display = "inline-block";
		musicnameDiv.className = "css_musicname_div_mobile";
		musicnameDiv.id = id + "musicnameDiv";
	
		var musicbufferImg = document.createElement("img");
		musicbufferImg.className = "css_music_buffer_img";
		musicbufferImg.src = music_buffer_spot1;
	
		var musicImgdiv = document.createElement("div");
		musicImgdiv.style.display = "float:right";
		musicImgdiv.className = "css_music_img_div_mobile";
		musicImgdiv.id = id + "musicImgdiv";
		var musicImgdivId = id + "musicImgdiv";
	
		var sourceImg = document.createElement("img");
		if (networkType == "1") {
			sourceImg.src = music_source_net;
		} else {
			sourceImg.style.display = "none";
		}
		sourceImg.className = "css_source_img_mobile";
		sourceImg.id = id + "sourceImg";
	
		var musicDividerVerticalImg = document.createElement("img");
		musicDividerVerticalImg.src = music_divider_vertical;
		musicDividerVerticalImg.className = "css_music_divider_vertical_img";
	
		var foldstateImg = document.createElement("img");
		foldstateImg.src = music_dot_fold_normal;
		foldstateImg.className = "css_music_foldstate_img_mobile";
		foldstateImg.id = id + "foldstateImg";
	
		foldstateImg.addEventListener('touchstart', touchstartstretch, false);
		foldstateImg.addEventListener('touchmove', touchmovestretch, false);
		foldstateImg.addEventListener('touchend', touchendstretch, false);
	
		var singerDiv = document.createElement("div");
		singerDiv.innerText = singer;
		singerDiv.className = "css_singer_div_mobile";
		singerDiv.id = id + "singerDiv";
	
		musicImgdiv.appendChild(sourceImg);
		musicImgdiv.appendChild(musicDividerVerticalImg);
		musicImgdiv.appendChild(foldstateImg);
	
		var stretchStatediv = document.createElement("div");
		stretchStatediv.className = "css_stretch_state_div";
		stretchStatediv.id = id + "stretchState";
		var stretchStatedivId = id + "stretchState";
	
		var downloadSongdiv = document.createElement("div");
		downloadSongdiv.innerText = "下载歌曲";
		downloadSongdiv.className = "css_set_as_polyphonic_ringtone_div";
	
		downloadSongdiv
				.addEventListener(
						"touchstart",
						function() {
							downloadSongdiv = event.target;
							downloadSongdiv.className = "css_set_as_polyphonic_ringtone_div_pressed";
							moveOverCheck.start(event);
							event.stopPropagation();
						}, false);
		downloadSongdiv.addEventListener("touchmove", function() {
			downloadSongdiv = event.target;
			if (moveOverCheck.check(event)) {
				move_music_song = true;
				downloadSongdiv.className = "css_set_as_polyphonic_ringtone_div";
			}
			event.stopPropagation();
		}, false);
		downloadSongdiv.addEventListener("touchend", function() {
			downloadSongdiv = event.target;
			downloadSongdiv.className = "css_set_as_polyphonic_ringtone_div";
			if (move_music_song == true) {
				move_music_song = false;
			} else {
				exec(musictaskHandler, 'downloadSong', [ idNumber ]);
			}
			event.stopPropagation();
		}, false);
	
		var stretchStateDividerImg1 = document.createElement("img");
		stretchStateDividerImg1.src = music_state_divider_vertical;
		stretchStateDividerImg1.className = "css_stretch_state_divider_Img1";
	
		var downloadRingingdiv = document.createElement("div");
		downloadRingingdiv.innerText = "下载铃声";
		downloadRingingdiv.className = "css_set_as_polyphonic_ringtone_div";
	
		downloadRingingdiv
				.addEventListener(
						"touchstart",
						function() {
							downloadRingingdiv = event.target;
							downloadRingingdiv.className = "css_set_as_polyphonic_ringtone_div_pressed";
							moveOverCheck.start(event);
							event.stopPropagation();
						}, false);
		downloadRingingdiv
				.addEventListener(
						"touchmove",
						function() {
							downloadRingingdiv = event.target;
							if (moveOverCheck.check(event)) {
								move_music_ring = true;
								downloadRingingdiv.className = "css_set_as_polyphonic_ringtone_div";
							}
							event.stopPropagation();
						}, false);
		downloadRingingdiv.addEventListener("touchend", function() {
			downloadRingingdiv = event.target;
			downloadRingingdiv.className = "css_set_as_polyphonic_ringtone_div";
			if (move_music_ring == true) {
				move_music_ring = false;
			} else {
				exec(musictaskHandler, 'downloadRinging', [ idNumber ]);
			}
			event.stopPropagation();
		}, false);
	
		var stretchStateDividerImg2 = document.createElement("img");
		stretchStateDividerImg2.src = music_state_divider_vertical;
		stretchStateDividerImg2.className = "css_stretch_state_divider_Img2";
	
		var setAsPolyphonicRingtonediv = document.createElement("div");
		setAsPolyphonicRingtonediv.innerText = "设为彩铃";
		setAsPolyphonicRingtonediv.className = "css_set_as_polyphonic_ringtone_div";
	
		setAsPolyphonicRingtonediv
				.addEventListener(
						"touchstart",
						function() {
							setAsPolyphonicRingtonediv = event.target;
							setAsPolyphonicRingtonediv.className = "css_set_as_polyphonic_ringtone_div_pressed";
							moveOverCheck.start(event);
							event.stopPropagation();
						}, false);
		setAsPolyphonicRingtonediv
				.addEventListener(
						"touchmove",
						function() {
							setAsPolyphonicRingtonediv = event.target;
							if (moveOverCheck.check(event)) {
								move_music_setRing = true;
								setAsPolyphonicRingtonediv.className = "css_set_as_polyphonic_ringtone_div";
							}
							event.stopPropagation();
						}, false);
		setAsPolyphonicRingtonediv
				.addEventListener(
						"touchend",
						function() {
							setAsPolyphonicRingtonediv = event.target;
							setAsPolyphonicRingtonediv.className = "css_set_as_polyphonic_ringtone_div";
							if (move_music_setRing == true) {
								move_music_setRing = false;
							} else {
								exec(musictaskHandler, 'setAsPolyphonicRingtone',
										[ idNumber ]);
							}
							event.stopPropagation();
						}, false);
	
		stretchStatediv.appendChild(downloadSongdiv);
		stretchStatediv.appendChild(stretchStateDividerImg1);
		stretchStatediv.appendChild(downloadRingingdiv);
		stretchStatediv.appendChild(stretchStateDividerImg2);
		stretchStatediv.appendChild(setAsPolyphonicRingtonediv);
	
		var playingFlag = document.createElement("div");
		playingFlag.className = "css_music_playing_flag";
	
		musicnameAndsourceAndfoldstateDiv.appendChild(musicnameDiv);
		musicnameAndsourceAndfoldstateDiv.appendChild(musicbufferImg);
		musicnameAndsourceAndfoldstateDiv.appendChild(stretchStatediv);
		musicnameAndsourceAndfoldstateDiv.appendChild(musicImgdiv);
	
		itemDiv.appendChild(playingFlag);
		itemDiv.appendChild(musicnameAndsourceAndfoldstateDiv);
		itemDiv.appendChild(singerDiv);
		itemDiv.setAttribute("ontouchstart", "touchstart('" + id + "')");
		itemDiv.setAttribute("ontouchmove", "touchmove('" + id + "')");
		itemDiv.setAttribute("ontouchend", "touchend('" + id + "')");
	
		return itemDiv;
	}
	var moveonfoldstate = false;
	touchstartstretch = function(event) {
		var foldstateImgId = event.target;
		foldstateImgId.src = music_dot_fold_pressed;
		moveOverCheck.start(event);
		event.stopPropagation();
	};
	touchmovestretch = function(event) {
		var foldstateImgId = event.target;
		foldstateImgId.src = music_dot_fold_pressed;
		if (moveOverCheck.check(event)) {
			moveonfoldstate = true;
			foldstateImgId.src = music_dot_fold_normal;
		}
		event.stopPropagation();
	};
	touchendstretch = function(event, id) {
		if (event != null && event != undefined) {
			var foldstateImgId = event.target;
			foldstateImgId.src = music_dot_fold_normal;
			var stringcommonId = foldstateImgId.id;
		} else {
			var stringcommonId = id;
		}
	
		if (moveonfoldstate == true) {
			moveonfoldstate = false;
		} else {
			var commonId = stringcommonId.substring(0, 6);
			var musicImgd = commonId + "musicImgdiv";
			document.getElementById(musicImgd).style.display = "none";
			var stretchState = commonId + "stretchState";
			document.getElementById(stretchState).style.display = "inline-block";
			var stateId = parseInt(commonId.charAt(5));
			for ( var j = 0; j < current_music_show_items; j++) {
				if (music_infomation.musicItems[j].networkType == "1") {
					if (j != stateId) {
						var stretchState = "music" + j + "stretchState";
						document.getElementById(stretchState).style.display = "none";
						var musicfoldState = "music" + j + "musicImgdiv";
						document.getElementById(musicfoldState).style.display = "inline-block";
					}
				}
	
			}
		}
		event.stopPropagation();
	};
	
	touchstart = function(id) {
		var element2 = document.getElementById(id);
		element2.style.background = "url('" + list_item_background_pressed + "')";
	
		moveOverCheck.start(event);
		setTimeout(function() {
			recoverBackground(element2);
		}, 5000);
	};
	function recoverBackground(element) {
		element.style.background = "";
	}
	touchmove = function(id) {
		document.getElementById(id).style.background = "";
	
		if (moveOverCheck.check(event)) {
			istouchmove = true;
		}
	};
	touchend = function(id) {
		if (istouchmove == true) {
			document.getElementById(id).style.background = "";
			istouchmove = false;
		} else {
			if (id == "music_more") {
				document.getElementById(id).style.background = "";
				exec(musictaskHandler, 'clickmore', []);
			} else {
				// FIXME 设计更改，点击音乐条目需要还原，点击更多不用还原。by mdhuang 2012年12月2日10:59:58
				if (cmcc_flag) {
					for ( var j = 0; j < current_music_show_items; j++) {
						if (music_infomation.musicItems[j].networkType == "1") {
							var stretchState = "music" + j + "stretchState";
							document.getElementById(stretchState).style.display = "none";
							var musicfoldState = "music" + j + "musicImgdiv";
							document.getElementById(musicfoldState).style.display = "inline-block";
						}
					}
				}
				
				var musicitem = document.getElementById(id);
				musicitem.style.background = "";
				console.log("---------------->touchend is going");
				exec(musictaskHandler, 'playMusic', [ id ]);
			}
		}
	};
	
	// 删除老的musicView
	function removeOldMusicView(){
		if (oldMusicView != null && oldMusicView.parentNode == document.body) {
			removeChild(document.body, oldMusicView);
			current_music_show_items = 5;
			// 调用java函数释放底层资源
			exec('WidgetMMPContainerComponents', 'removeViewForJs',
					[ musictaskHandler ]);
		}
	}
	
	/**
	 * 创建音乐主界面
	 * 
	 * @param musicInfo
	 *            音乐信息
	 */
	function createMusicView(musicInfo) {
		// alert('createMusicView begin, musicInfo is '+ musicInfo);
		console.log("oldMusicView is started");
	
		// 删除老的musicView
		removeOldMusicView();
	
		music_infomation = musicInfo;
		var taskHandler = musicInfo.taskHandler;
		musictaskHandler = taskHandler;
		var items = musicInfo.musicListLength;
		var dialog_music_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_music_canvas.className = "css_dialog_absolute_bg";
	
		// 音乐播放界面
		var dialog_music_div = document.createElement("div");
		dialog_music_div.className = "css_dialog_music_div";
	
		var dialog_musicplayer_inner_div = document.createElement("div");
		dialog_musicplayer_inner_div.className = "css_dialog_musicplayer_inner";
	
		var music_name_and_pauseimg_div = document.createElement("div");
		music_name_and_pauseimg_div.style.display = "inline-block";
		music_name_and_pauseimg_div.className = "css_music_name_and_pauseimg_div";
	
		var music_name_div = document.createElement("div");
		music_name_div.id = "musicplayermusicname";
		music_name_div.className = "css_music_name_div";
		music_name_div.innerText = musicInfo.musicItems[0].musicName;
		
		
	
		var music_singer_div = document.createElement("div");
		music_singer_div.id = "musicplayersinger";
		music_singer_div.innerText = musicInfo.musicItems[0].musicSinger;
	
		music_singer_div.className = "css_music_singer_div";
	
		var dialog_music_pauseImg = document.createElement("img");
		dialog_music_pauseImg.id = "musicplayerpauseImg";
		dialog_music_pauseImg.src = music_pause_normal;
		dialog_music_pauseImg.className = "css_dialog_music_pause_img";
	
		music_name_and_pauseimg_div.appendChild(music_name_div);
		music_name_and_pauseimg_div.appendChild(dialog_music_pauseImg);
	
		var dialog_music_progress_timeshow_section = document
				.createElement("section");
		dialog_music_progress_timeshow_section.id = "progresstimeshowsection";
		dialog_music_progress_timeshow_section.style.display = "block";
		dialog_music_progress_timeshow_section.className = "css_dialog_music_progress_timeshow_section";
	
		var dialog_music_progressbar_outer_div = document.createElement("div");
		dialog_music_progressbar_outer_div.id = "outerprogressbar";
		dialog_music_progressbar_outer_div.className = "css_dialog_music_progressbar_outer_div";
	
		var dialog_music_bufferprogress_div = document.createElement("div");
		dialog_music_bufferprogress_div.id = "bufferprogressbar";
		dialog_music_bufferprogress_div.className = "css_dialog_music_buffer_progressbar_div";
	
		var dialog_music_progressbar_div = document.createElement("div");
		dialog_music_progressbar_div.id = "progressbar";
		dialog_music_progressbar_div.className = "css_dialog_music_progressbar_div";
	
		dialog_music_progressbar_outer_div
				.appendChild(dialog_music_bufferprogress_div);
		dialog_music_progressbar_outer_div
				.appendChild(dialog_music_progressbar_div);
	
		var dialog_music_presenttime = document.createElement("div");
		dialog_music_presenttime.id = "presenttimeshow";
		dialog_music_presenttime.className = "css_dialog_music_presenttime_div";
	
		var dialog_music_totaltime = document.createElement("div");
		dialog_music_totaltime.id = "totaltimeshow";
		dialog_music_totaltime.className = "css_dialog_music_totaltime_div";
	
		dialog_music_progress_timeshow_section
				.appendChild(dialog_music_progressbar_outer_div);
		dialog_music_progress_timeshow_section
				.appendChild(dialog_music_presenttime);
		dialog_music_progress_timeshow_section.appendChild(dialog_music_totaltime);
	
		//添加请求百分比
		var requesting_percent_source_pool_div = document.createElement("div");
		requesting_percent_source_pool_div.className = "css_requesting_percent_source_pool_div";
		
		var requesting_percent_div = document.createElement("div");
		requesting_percent_div.className = "css_requesting_percent_div";
		requesting_percent_div.id = "music_requesting_percent_div";
		requesting_percent_div.innerText = "";
		
		
		var dialog_music_source_pool_div = document.createElement("div");
		dialog_music_source_pool_div.className = "css_dialog_music_source_pool_div";
		var dialog_music_source_pool_img = document.createElement("img");
		dialog_music_source_pool_img.src = music_source_pool;
		dialog_music_source_pool_img.className = "css_dialog_music_source_pool_img";
		dialog_music_source_pool_img.id = "music_source_pool_img";
	
		var dialog_music_source_pool_text = document.createElement("div");
		dialog_music_source_pool_text.id = "music_source_pool";
		dialog_music_source_pool_text.className = "css_dialog_music_source_pool_text";
	
		dialog_music_source_pool_div.appendChild(dialog_music_source_pool_img);
		dialog_music_source_pool_div.appendChild(dialog_music_source_pool_text);
		
		requesting_percent_source_pool_div.appendChild(requesting_percent_div);
		requesting_percent_source_pool_div.appendChild(dialog_music_source_pool_div);
	
		dialog_musicplayer_inner_div.appendChild(music_name_and_pauseimg_div);
		dialog_musicplayer_inner_div.appendChild(music_singer_div);
		dialog_musicplayer_inner_div
				.appendChild(dialog_music_progress_timeshow_section);
		dialog_musicplayer_inner_div.appendChild(requesting_percent_source_pool_div);
	
		// 音乐列表
		var outDiv = createOutDiv();
		if (enableAnimation && isChangingSkin == false) {
			outDiv.className += " css_dialog_opacity_animation";
		}
		var dialog_music_inner_div = document.createElement("div");
	
		if (items < current_music_show_items) {
			current_music_show_items = items;
		}
		var lastItem = null;
		// 创建主界面音乐列表项
		for ( var i = 0; i < current_music_show_items; i++) {
			if (cmcc_flag) {
				if (musicInfo.musicItems[i].networkType == "0") {
					var item = createMusicItem2("music" + i,
							musicInfo.musicItems[i].musicName,
							musicInfo.musicItems[i].musicSinger,
							musicInfo.musicItems[i].networkType);
				} else {
					var item = createMusicItem("music" + i,
							musicInfo.musicItems[i].musicName,
							musicInfo.musicItems[i].musicSinger,
							musicInfo.musicItems[i].networkType);
				}
			} else {
				var item = createMusicItem2("music" + i,
						musicInfo.musicItems[i].musicName,
						musicInfo.musicItems[i].musicSinger,
						musicInfo.musicItems[i].networkType);
			}
			dialog_music_inner_div.appendChild(item);
	
			if ((i + 1) != current_music_show_items) {
				dialog_music_inner_div.appendChild(createRestaurantDivier());
			}
			if (i == current_music_show_items - 1) {
				lastItem = item;
			}
		}
		var btn_more = null;
		// 如果返回的歌曲数量大于5条，则在显示5条音乐项之后显示更多按钮
		if (items > 5) {
			dialog_music_inner_div.appendChild(createRestaurantDivier());
			var btn_more_div = document.createElement("div");
			btn_more_div.className = "css_btn_more_div";
			btn_more_div.id = "music_more";
	
			btn_more = document.createElement("div");
			btn_more.innerText = "查看更多";
			btn_more.style.display = "inline-block";
			btn_more.className = "css_btn_more";
	
			var arrow_img_div = document.createElement("div");
			arrow_img_div.style.display = "inline-block";
			arrow_img_div.className = "css_arrow_img_div";
			var arrow_img = document.createElement("img");
			arrow_img.id = "arrow_right";
			arrow_img.src = dialog_goto_right_icon;
			arrow_img.className = "css_arrow_img";
			arrow_img_div.appendChild(arrow_img);
	
			btn_more_div.appendChild(btn_more);
			btn_more_div.appendChild(arrow_img_div);
			btn_more_div.setAttribute("ontouchstart", "touchstart('music_more')");
			btn_more_div.setAttribute("ontouchmove", "touchmove('music_more')");
			btn_more_div.setAttribute("ontouchend", "touchend('music_more')");
			dialog_music_inner_div.appendChild(btn_more_div);
		}
		dialog_music_div.appendChild(dialog_musicplayer_inner_div);
		dialog_music_div.appendChild(dialog_music_inner_div);
	
		outDiv.appendChild(dialog_music_canvas);
		outDiv.appendChild(dialog_music_div);
	
		// //FIXME 设计更改，这里不用进行还原。by mdhuang 2012年12月2日10:59:58
		// dialog_musicplayer_inner_div.addEventListener("click",function(){
		// for(var j = 0; j<current_music_show_items;j++){
		// if(music_infomation.musicItems[j].networkType == "1"){
		// var stretchState = "music" + j + "stretchState";
		// document.getElementById(stretchState).style.display = "none";
		// var musicfoldState = "music" + j + "musicImgdiv";
		// document.getElementById(musicfoldState).style.display = "inline-block";
		// }
		// }
		// },false);
	
		document.body.appendChild(outDiv);
		oldMusicView = outDiv;
	
		var canvasHeight = dialog_music_div.clientHeight;
		dialog_music_canvas.setAttribute("height", canvasHeight + "px");
		console.log("canvasHeight:" + canvasHeight);
		draw(dialog_music_canvas, img_dialog_view_bg, dialog_view_bg_coordinates);
	
		// 播放按钮点击事件
		dialog_music_pauseImg
				.addEventListener(
						"touchstart",
						function() {
							if (music_view_state == "PLAYING"
									|| music_view_state == "REQUESTING") {
								document.getElementById("musicplayerpauseImg").src = music_pause_pressed;
							} else {
								document.getElementById("musicplayerpauseImg").src = music_play_pressed;
							}
						}, false);
	
		dialog_music_pauseImg
				.addEventListener(
						"touchend",
						function() {
							if (music_view_state == "READY") {
								document.getElementById("musicplayerpauseImg").src = music_pause_normal;
								exec(taskHandler, 'resumemusic', []);
							} else if (music_view_state == "REQUESTING") {
								document.getElementById("musicplayerpauseImg").src = music_play_normal;
								exec(taskHandler, 'pauseMusic', []);
							} else if (music_view_state == "PLAYING") {
								document.getElementById("musicplayerpauseImg").src = music_play_normal;
								exec(taskHandler, 'pauseMusic', []);
							} else if (music_view_state == "PAUSED") {
								document.getElementById("musicplayerpauseImg").src = music_pause_normal;
								exec(taskHandler, 'resumemusic', []);
							} else if (music_view_state == "ERROR") {
								document.getElementById("musicplayerpauseImg").src = music_pause_normal;
								exec(taskHandler, 'resumemusic', []);
							}
						}, false);
	
		showOpacityAnimation(outDiv, 150);
		return outDiv;
	}
	
	/**
	 * java回调，二级界面点击更多时获取所有歌曲信息。
	 * 
	 * @param musicInfo
	 *            歌曲信息
	 */
	function getMoreMusicInformation(musicInfo) {
		music_infomation = musicInfo;
	}
	
	/**
	 * java回调，更新音乐播放状态。不同的状态，界面会做相应的响应。
	 * 
	 * @param music_state
	 *            音乐状态，字符串类型
	 * @param index
	 *            歌曲索引，整型
	 */
	function updateMusicState(music_state, index) {
		console.error("music state is " + music_state + " ,index is " + index);
		// 处理index为-1的情况
		if (index < 0) {
			index = 0;
		}
		mindex = index;
		var mID = "music" + index;
		
		// 点击某首歌曲，该歌曲进入READY状态，该歌曲所在列项显示播放标志，播放界面显示歌曲名和歌手名。
		if (music_state == "READY") {
			document.getElementById("musicplayerpauseImg").src = music_play_normal;
			document.getElementById("progressbar").style.width = "0px";
			document.getElementById("bufferprogressbar").style.width = "0px";
			document.getElementById("presenttimeshow").innerHTML = "00:00/";
			document.getElementById("totaltimeshow").innerHTML = "00:00";
			document.getElementById("music_source_pool_img").style.display = "none";
			document.getElementById("music_source_pool").innerHTML = "";
			document.getElementById("musicplayermusicname").innerHTML = music_infomation.musicItems[index].musicName;
			document.getElementById("musicplayersinger").innerHTML = music_infomation.musicItems[index].musicSinger;
			// READY状态下不显示缓冲图片
			if (index < current_music_show_items) {
				document.getElementById(mID).children[1].children[1].style.display = "none";
			}
			// 本地歌曲，令缓冲进度为100%
			if (music_infomation.musicItems[index].networkType == 0) {
				updateMusicBuffer(100);
			}
			recordSecond = 0;
			document.getElementById("music_requesting_percent_div").innerText = "";
	
		} else if (music_state == "REQUESTING") {
			document.getElementById("musicplayerpauseImg").src = music_pause_normal;
			if (index < current_music_show_items) {
				// for循环为当前歌曲设置正在播放的标志，其他歌曲隐藏播放标志
				for ( var j = 0; j < current_music_show_items; j++) {
					var musicitemId = "music" + j;
					if (j == index) {
						console.log("---------------->updateMusicState is going");
						document.getElementById(musicitemId).children[0].className = "css_music_playing_flag2";
					} else {
						document.getElementById(musicitemId).children[0].className = "css_music_playing_flag";
					}
				}
			} else {
				// 非主界面歌曲播放时，设置主界面歌曲的播放标志为隐藏
				for ( var j = 0; j < 5; j++) {
					var musicitemId = "music" + j;
					document.getElementById(musicitemId).children[0].className = "css_music_playing_flag";
				}
			}
			if (index < current_music_show_items) {
				// 音乐请求状态下，当前音乐显示缓冲图片
				for ( var j = 0; j < current_music_show_items; j++) {
					var musicitemId = "music" + j;
					if (j == index) {
						document.getElementById(musicitemId).children[1].children[1].style.display = "inline-block";
					} else {
						document.getElementById(musicitemId).children[1].children[1].style.display = "none";
					}
				}
			} else {
				// 若当前播放的音乐不在主界面列表，则主界面列表所有歌曲的缓冲图片不显示
				for ( var j = 0; j < 5; j++) {
					var musicitemId = "music" + j;
					document.getElementById(musicitemId).children[1].children[1].style.display = "none";
				}
			}
			// 开始缓冲，3张缓冲图片来回切换
			if (index < current_music_show_items) {
				buffershow(mID);
			}
			
			clearTimeout(requestingSetTimeoutId);
			showRequestingPercent();
		} else if (music_state == "PLAYING") {
			document.getElementById("musicplayerpauseImg").src = music_pause_normal;
			// 播放状态缓冲图片不显示
			if (index < current_music_show_items) {
				document.getElementById(mID).children[1].children[1].style.display = "none";
			}
		} else if (music_state == "PAUSED") {
			document.getElementById("musicplayerpauseImg").src = music_play_normal;
			if (index < current_music_show_items) {
				document.getElementById(mID).children[1].children[1].style.display = "none";
			}
		} else if (music_state == "ERROR") {
			document.getElementById("musicplayerpauseImg").src = music_play_normal;
			document.getElementById("music_requesting_percent_div").innerText = "";
			// 播放出错状态下缓冲图片不显示，播放标志不显示
			for ( var j = 0; j < current_music_show_items; j++) {
				var musicitemId = "music" + j;
				document.getElementById(musicitemId).children[0].className = "css_music_playing_flag";
				document.getElementById(musicitemId).children[1].children[1].style.display = "none";
			}
		}
		music_view_state = music_state;
		music_buffer_state = music_state + mID;
	}
	
	var networkWifi = false;//记录当前网络类型
	//java回调函数
	function judgeNetworkWifi(networkWIFI){
		networkWifi = networkWIFI;
	}
	
	var recordSecond = 0;//记录缓冲请求百分数
	var requestingSetTimeoutId;//记录setTimeOut的id
	var disappearSetTimeoutId;//记录setTimeOut的id
	//显示请求百分比
	function showRequestingPercent(){
		var requestingPercent = recordSecond;
		if(music_view_state == "REQUESTING"){
			if(recordSecond <= 99){
				document.getElementById("music_requesting_percent_div").innerText = requestingPercent + "%";
			}else{
				document.getElementById("music_requesting_percent_div").innerText = "99%";
			}
			recordSecond++;
			if(networkWifi){
				requestingSetTimeoutId = setTimeout(showRequestingPercent,50);
				console.log('----------------->networkWifi:' + networkWifi);
			}else{
				requestingSetTimeoutId = setTimeout(showRequestingPercent,100);
				console.log('----------------->networkWifi:' + networkWifi);
			}
			
		}else if(music_view_state == "PLAYING"){
			document.getElementById("music_requesting_percent_div").innerText = "100%";
			disappearSetTimeoutId = setTimeout(disappearRequestingPercent,100);
		}
	}
	
	//显示100%一秒钟后消失
	function disappearRequestingPercent(){
		document.getElementById("music_requesting_percent_div").innerText = "";
		recordSecond = 0;
		clearTimeout(disappearSetTimeoutId);
	}
	
	/**
	 * 音乐在REQUESTING状态下缓冲图片显示。三张缓冲图片切换。
	 * 
	 * @param id
	 *            音乐id，格式为music2，字符串类型
	 */
	function buffershow(id) {
		if (music_view_state != "REQUESTING") {
			clearTimeout(intervalID);
		}
		console.log('----------------->buffershow');
		var bufferImgArray = [ music_buffer_spot1, music_buffer_spot2,
				music_buffer_spot3 ];
		counter = counter % 3;
		document.getElementById(id).children[1].children[1].src = bufferImgArray[counter];
		counter++;
		if (mindex < current_music_show_items) {
			var presentState = "REQUESTING" + id;
			if (music_buffer_state == presentState) {
				var intervalID = setTimeout(function() {
					buffershow(id)
				}, 300);
			}
		}
	}
	
	/**
	 * java回调，更新歌曲已播放时长和总时长。
	 * 
	 * @param currentTime
	 *            音乐当前播放时间长度，单位为毫秒
	 * @param currentDuration
	 *            音乐总时长，单位为毫秒
	 * 
	 */
	function updateMusicShow(currentTime, currentDuration) {
		var mCurrentTime = parseInt(currentTime / 1000);
		var mCurrentDuration = parseInt(currentDuration / 1000);
		document.getElementById("presenttimeshow").innerHTML = convertTimeFormat(mCurrentTime)
				+ "/";
		document.getElementById("totaltimeshow").innerHTML = convertTimeFormat(mCurrentDuration);
	
		var mPercent = mCurrentTime / mCurrentDuration * 100;
		console.log('------------------>mPercent:' + mPercent);
		document.getElementById("progressbar").style.width = mPercent + "%";
	
		// FIXME 播放一段时间后自动调用touchendstretch。by mdhuang 2012年12月1日11:26:25
		if (cmcc_flag) {
			if (mCurrentTime >= 3 && mCurrentTime <= 5) {
				var musicId = "music" + mindex;
				var foldstateImg = document
						.getElementById(musicId + "foldstateImg");
				if (foldstateImg != null) {
					touchendstretch(null, musicId);
				}
			}
		}
	}
	
	/*
	 * java回调，当当前歌曲来源为联通沃音乐时，界面才显示歌曲来源。
	 */
	function javacallbackMusicSource(musicSource) {
		console.log('-------------------->javacallbackMusicSource' + musicSource);
		if (musicSource == "联通沃音乐") {
			document.getElementById("music_source_pool_img").style.display = "inline-block";
			document.getElementById("music_source_pool").innerHTML = musicSource;
		} else {
			document.getElementById("music_source_pool_img").style.display = "none";
			document.getElementById("music_source_pool").innerHTML = "";
		}
	}
	
	/**
	 * java回调，更新缓冲进度。
	 * 
	 * @param bufferPercent
	 *            当前音乐缓冲进度，为整型
	 * 
	 */
	function updateMusicBuffer(bufferPercent) {
		mBufferPercent = bufferPercent;
		console.log('----------------->updateMusicBuffer');
		document.getElementById("bufferprogressbar").style.width = bufferPercent
				+ "%";
	}
	
	/**
	 * 时间格式转换。返回结果result是歌曲时间，显示样式为，例如03:37。
	 * 
	 * @param oldtime
	 *            时间，整型，单位为秒
	 */
	function convertTimeFormat(oldtime) {
		var colonbefore = parseInt(oldtime / 60);
		var colonnext = parseInt(oldtime) % 60;
		if (colonbefore >= 10 && colonnext >= 10) {
			result = "" + colonbefore + ":" + colonnext;
		} else if (colonbefore < 10 && colonnext >= 10) {
			result = "0" + colonbefore + ":" + colonnext;
		} else if (colonbefore >= 10 && colonnext < 10) {
			result = colonbefore + ":0" + colonnext;
		} else
			result = "0" + colonbefore + ":0" + colonnext;
		return result;
	}
	


	/*************** 支持音乐频道自有歌曲的播放显示 ******************/
	function updateWapMusicState(music_state, singer, songName) {
		console.log("updateWapMusicState " + music_state + " ,singer is "
				+ singer + " ,songName is " + songName);

		// 点击某首歌曲，该歌曲进入READY状态，该歌曲所在列项显示播放标志，播放界面显示歌曲名和歌手名。
		if (music_state == "READY") {
			document.getElementById("musicplayerpauseImg").src = music_play_normal;
			document.getElementById("progressbar").style.width = "0px";
			document.getElementById("bufferprogressbar").style.width = "0px";
			document.getElementById("presenttimeshow").innerHTML = "00:00/";
			document.getElementById("totaltimeshow").innerHTML = "00:00";
			document.getElementById("music_source_pool_img").style.display = "none";
			document.getElementById("music_source_pool").innerHTML = "";
			document.getElementById("musicplayermusicname").innerHTML = songName;
			document.getElementById("musicplayersinger").innerHTML = singer;
			recordSecond = 0;
			document.getElementById("music_requesting_percent_div").innerText = "";
		} else if (music_state == "REQUESTING") {
			document.getElementById("musicplayerpauseImg").src = music_pause_normal;

			// 非主界面歌曲播放时，设置主界面歌曲的播放标志为隐藏
			for ( var j = 0; j < current_music_show_items; j++) {
				var musicitemId = "music" + j;
				document.getElementById(musicitemId).children[0].className = "css_music_playing_flag";
				document.getElementById(musicitemId).children[1].children[1].style.display = "none";
			}

			clearTimeout(requestingSetTimeoutId);
			showRequestingPercent();
		} else if (music_state == "PLAYING") {
			document.getElementById("musicplayerpauseImg").src = music_pause_normal;
		} else if (music_state == "PAUSED") {
			document.getElementById("musicplayerpauseImg").src = music_play_normal;
		} else if (music_state == "ERROR") {
			document.getElementById("musicplayerpauseImg").src = music_play_normal;
			document.getElementById("music_requesting_percent_div").innerText = "";
			// 播放出错状态下缓冲图片不显示，播放标志不显示
			for ( var j = 0; j < current_music_show_items; j++) {
				var musicitemId = "music" + j;
				document.getElementById(musicitemId).children[0].className = "css_music_playing_flag";
				document.getElementById(musicitemId).children[1].children[1].style.display = "none";
			}
		}
		
		music_view_state = music_state;
	}
	
	function showWapMusicTime(currentTime, currentDuration){
		var mCurrentTime = parseInt(currentTime / 1000);
		var mCurrentDuration = parseInt(currentDuration / 1000);
		document.getElementById("presenttimeshow").innerHTML = convertTimeFormat(mCurrentTime) + "/";
		document.getElementById("totaltimeshow").innerHTML = convertTimeFormat(mCurrentDuration);
		var mPercent = mCurrentTime / mCurrentDuration * 100;
		console.log('------------------>mPercent:' + mPercent);
		document.getElementById("progressbar").style.width = mPercent + "%";
	
		// 播放一段时间后自动调用touchendstretch。
		if (cmcc_flag) {
			if (mCurrentTime >= 3 && mCurrentTime <= 5) {
				var musicId = "music" + mindex;
				var foldstateImg = document.getElementById(musicId + "foldstateImg");
				if (foldstateImg != null) {
					touchendstretch(null, musicId);
				}
			}
		}
	}
	
	function showWapMusicBufferPercent(percent){
		console.log('----------------->updateMusicBuffer');
		document.getElementById("bufferprogressbar").style.width = bufferPercent + "%";
	}
	
	// 将需要java回调的函数暴露到全局对象musicView中，方便外部java文件调用
	window.musicView = window.musicView || {};
	console.log(musicView);
	musicView.updateMusicBuffer = updateMusicBuffer;
	musicView.javacallbackMusicSource = javacallbackMusicSource;
	musicView.updateMusicShow = updateMusicShow;
	musicView.updateMusicState= updateMusicState;
	musicView.getMoreMusicInformation = getMoreMusicInformation;
	musicView.judgeNetworkWifi = judgeNetworkWifi;
	musicView.updateWapMusicState = updateWapMusicState;
	musicView.showWapMusicTime = showWapMusicTime;
	musicView.showWapMusicBufferPercent = showWapMusicBufferPercent;
	musicView.removeOldMusicView = removeOldMusicView;
	
	return createMusicView;
});