/**
 * 电话号码列表视图
 * 
 * @author leleliu008
 * @author modified by mdhuang 2013-3-22
 */
define(function() {
	function createPhoneTag(phoneTagStr) {
		var phoneTagDiv = document.createElement("div");
		phoneTagDiv.className = "css_dialog_phone_tag_container css_dialog_phone_highlight_color";
		phoneTagDiv.innerText = phoneTagStr;
		return phoneTagDiv;
	}
	// // 号码列表的每一项
	// function createPhoneNumItem(phoneId, cellPhoneFlag, phoneTag,
	// markUpPhoneNum, phoneFunctionIconSrc) {
	// var phoneItem = document.createElement("div");
	// phoneItem.id = phoneId;
	// phoneItem.className = "css_dialog_phone_item";
	//
	// var phoneNumDiv = document.createElement("div");
	// phoneNumDiv.className = "css_dialog_phone_num_container_short";
	//
	// var functionIconContainer = document.createElement("div");
	// functionIconContainer.className =
	// "css_dialog_phone_function_icon_container";
	// var functionIcon = document.createElement("img");
	// functionIcon.className = "css_dialog_phone_function_icon";
	// functionIcon.src = phoneFunctionIconSrc;
	// functionIconContainer.appendChild(functionIcon);
	//
	// var phoneShowString = "";
	// var markPosition = markUpPhoneNum.indexOf("&");
	// if (markPosition == -1) {
	// if (phoneTag != "" && phoneTag != null) {
	// phoneItem.appendChild(createPhoneTag(phoneTag));
	// } else {
	// phoneNumDiv.className = "css_dialog_phone_num_container_long";
	// }
	// if (cellPhoneFlag) {
	// phoneShowString = markUpPhoneNum.substring(0, 3) + " "
	// + markUpPhoneNum.substring(3, 7) + " "
	// + markUpPhoneNum.substring(7);
	// } else {
	// phoneShowString = markUpPhoneNum;
	// }
	// phoneNumDiv.innerHTML = phoneShowString;
	//
	// phoneItem.appendChild(phoneNumDiv);
	// phoneItem.appendChild(functionIconContainer);
	//
	// return phoneItem;
	// }
	// if (phoneTag != "" && phoneTag != null) {
	// phoneItem.appendChild(createPhoneTag(phoneTag));
	// } else {
	// phoneNumDiv.className = "css_dialog_phone_num_container_long";
	// }
	// var sArray = markUpPhoneNum.split("&");
	// if (markPosition == 0) {
	// var lastPosition = markUpPhoneNum.lastIndexOf("&");
	//
	// if (lastPosition == markUpPhoneNum.length - 1) {
	// console.log(sArray[1]);
	// if (cellPhoneFlag) {
	// var s = sArray[1].substring(0, 3) + " "
	// + sArray[1].substring(3, 7) + " "
	// + sArray[1].substring(7);
	// phoneShowString = phoneNumJSpre + s + phoneJSpost;
	// } else {
	// phoneShowString = phoneNumJSpre + sArray[1] + phoneJSpost;
	// }
	//
	// } else {
	// var s1 = phoneNumJSpre + sArray[1] + phoneJSpost + " ";
	// var s2 = sArray[2].substring(0, 4) + " "
	// + sArray[2].substring(4);
	// phoneShowString = s1 + s2;
	// }
	// } else if (markPosition > 6) {
	// var s1 = sArray[0].substring(0, 3) + " " + sArray[0].substring(3)
	// + " ";
	// var s2 = phoneNumJSpre + sArray[1] + phoneJSpost;
	// phoneShowString = s1 + s2;
	// } else {
	// phoneShowString = sArray[0] + " " + phoneNumJSpre + sArray[1]
	// + phoneJSpost + " " + sArray[2];
	// }
	//
	// phoneNumDiv.innerHTML = phoneShowString;
	//
	// phoneItem.appendChild(phoneNumDiv);
	// phoneItem.appendChild(functionIconContainer);
	// return phoneItem;
	// }

	// 号码列表创建
	function createPhoneNumView(phoneInfo) {
		var phoneNumList = phoneInfo.phoneNumList;
		var phoneTagList = phoneInfo.phoneTagList;
		var phoneFlagList = phoneInfo.phoneFlagList;
		var taskHandler = phoneInfo.taskHandler;
		var phoneFocus = phoneInfo.phoneViewFocus;

		var defaultItemId = null;
		var phoneFunctionIconSrc = dialog_call_icon;
		if (phoneFocus == "message") {
			phoneFunctionIconSrc = dialog_message_icon;
		} else {
			if (phoneInfo.defaultItem > -1) {
				defaultItemId = "phoneItem" + phoneInfo.defaultItem;
			}
		}

		var outDiv = createOutDiv();
		var dialog_contact_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_contact_canvas.className = "css_dialog_absolute_bg";

		var dialog_contact_inner_div = document.createElement("div");
		dialog_contact_inner_div.className = "css_dialog_contact_inner_div";

		var dialog_phone_title_div = document.createElement("div");
		dialog_phone_title_div.className = "css_dialog_phone_title_container";
		dialog_phone_title_div.innerText = phoneInfo.phoneViewTitle;

		// var dialog_phone_title_div = createContactItem("",
		// phoneInfo.phoneViewTitle, phoneInfo.phoneViewIcon,
		// "css_dialog_phone_title_container");

		dialog_contact_inner_div.appendChild(dialog_phone_title_div);

		for ( var i = 0; i < phoneNumList.length; i++) {
			var defaultItemParam = (phoneInfo.defaultItem === i ? defaultItemId
					: null);
			var phoneItem = createContactNumberItem("phoneItem" + i,
					phoneFlagList[i], phoneTagList[i], phoneNumList[i], "", "",
					defaultItemParam, phoneFunctionIconSrc);
			dialog_contact_inner_div.appendChild(phoneItem);
			if (i < phoneNumList.length - 1) {
				dialog_contact_inner_div.appendChild(createRestaurantDivier());
			}
		}

		outDiv.appendChild(dialog_contact_canvas);
		outDiv.appendChild(dialog_contact_inner_div);
		var rotatedId = null;
		if (defaultItemId !== null) {
			var cancel_bottom_div = document.createElement("div");
			cancel_bottom_div.className = "css_dialog_appList_bottom_btn_div";
			cancel_bottom_div.style.height = dialog_title_canvas_height + "px";
			cancel_bottom_div.style.lineHeight = dialog_title_canvas_height
					+ "px";

			var cancel_btn_canvas = createBgCanvas(dialog_box_canvas_width);
			cancel_btn_canvas.className = "css_dialog_absolute_bg";
			cancel_btn_canvas.setAttribute("height", dialog_title_canvas_height + "px");

			var cancel_btntext_div = document.createElement("div");
			cancel_btntext_div.className = "css_dialog_bottom_btntext_div";
			cancel_btntext_div.innerText = "取 消";

			cancel_bottom_div.appendChild(cancel_btn_canvas);
			cancel_bottom_div.appendChild(cancel_btntext_div);

			outDiv.appendChild(cancel_bottom_div);

			draw(cancel_btn_canvas, img_dialog_btnnomal_bg,
					dialog_btn_bg_coordinates);

			cancel_btntext_div.addEventListener("touchstart", function() {
				reDraw(cancel_btn_canvas, img_dialog_btnpressed_bg,
						dialog_btn_bg_coordinates);
			}, false);
			cancel_btntext_div.addEventListener("touchmove", function() {
				reDraw(cancel_btn_canvas, img_dialog_btnnomal_bg,
						dialog_btn_bg_coordinates);
			}, false);
			cancel_btntext_div.addEventListener("touchend", function() {
				reDraw(cancel_btn_canvas, img_dialog_btnnomal_bg,
						dialog_btn_bg_coordinates);
				removeChild(document.body, outDiv);
				exec(taskHandler, 'cancel', []);
				// 通知java函数释放相关资源
				exec('WidgetMMPContainerComponents', 'removeViewForJs',
						[ taskHandler ]);
			}, false);
		}

		document.body.appendChild(outDiv);

		var canvasHeight = dialog_contact_inner_div.clientHeight;
		dialog_contact_canvas.setAttribute("height", canvasHeight + "px");
		console.log("canvasHeight:" + canvasHeight);

		// 设置大背景图片
		draw(dialog_contact_canvas, dialogmode_contact_bg,
				dialog_view_bg_coordinates);

		if (defaultItemId !== null) {
			var defaultNumCanvas = document.getElementById("defaultPhoneNum");
			var defaultNumcxt = defaultNumCanvas.getContext("2d");
			rotatedId = startRotate(defaultNumCanvas);
		}

		// 设置当前可删除view
		currentCanDeleteView = outDiv;
		var touchObj = {
			returnArgument : null,
			touchElement : null,
			touchStart : function(event) {
				// this.touchElement = getParentOfClass("css_dialog_phone_item",
				// event.target);
				this.touchElement = getParentOfClass(
						"css_dialog_contact_search_item_container",
						event.target);
				if (this.touchElement != null) {
					this.touchElement.style.background = "url('"
							+ list_item_background_pressed + "')";
				} else {
					this.touchElement = null;
				}
			},
			touchMove : function() {
				if (this.touchElement != null) {
					this.touchElement.style.background = "";
				}
			},
			touchEnd : function() {
				if (this.touchElement != null) {
					this.touchElement.style.background = "";
					this.returnArgument = this.touchElement.id;
					console.log("get touch element id " + this.returnArgument);
				}
				this.touchElement = null;
			}
		};
		enableScrollTouch(dialog_contact_inner_div, 15, touchObj);
		dialog_contact_inner_div.addEventListener("scrolltouch", function() {
			removeChild(document.body, outDiv);
			forceRefreshScreen();
			currentCanDeleteView = null;
			exec(taskHandler, 'phoneItemClick', [ touchObj.returnArgument ]);
			touchObj.returnArgument = null;
			outDiv.deleteView();
		}, false);
		outDiv.deleteView = function() {
			if (defaultItemId !== null) {
				stopRotate(rotatedId);
			}
			// 通知java函数释放相关资源
			exec('WidgetMMPContainerComponents', 'removeViewForJs',
					[ taskHandler ]);
		};
		outDiv.refresh = function() {
			// 背景
			reDraw(dialog_contact_canvas, dialogmode_contact_bg,
					dialog_view_bg_coordinates);

			// 分割线
			var lineElements = document
					.getElementsByClassName('css_dialog_restaurant_divider_line');
			if (lineElements != null && lineElements.length > 0) {
				for ( var i = 0; i < lineElements.length; i++) {
					lineElements[i].style.backgroundImage = "url('"
							+ dialog_list_divider + "')";
				}
			}
		};
		return outDiv;
	}
	
	return createPhoneNumView;
});