define(function() {
	function createRemindConfirmView(remindInfo) {
		var remindTaskHandler = remindInfo.taskHandler;
		// 大背景
		var dialog_remind_confirm_canvas = createBgCanvas(dialog_box_canvas_width);
		dialog_remind_confirm_canvas.className = "css_dialog_absolute_bg";
		// 真正盛放内容的容器
		var dialog_remind_confirm_inner_div = document.createElement("div");
		dialog_remind_confirm_inner_div.className = "css_dialog_remind_inner";

		for (var i = 0; i < 2; i++) {
			var itemDiv = createRemindConfirmItemView(remindTaskHandler, i, remindInfo.array[i]);
			dialog_remind_confirm_inner_div.appendChild(itemDiv);
			if (i == 0) {
				// 分割线
				var dialog_remind_line = document.createElement("div");
				dialog_remind_line.className = "css_dialog_divider_line";
				dialog_remind_line.style.backgroundImage = "url('" + dialog_list_divider + "')";
				dialog_remind_confirm_inner_div.appendChild(dialog_remind_line);
			}
		}
		var outDiv = createOutDiv();
		outDiv.appendChild(dialog_remind_confirm_canvas);
		outDiv.appendChild(dialog_remind_confirm_inner_div);
		document.body.appendChild(outDiv);

		var canvasHeight = dialog_remind_confirm_inner_div.clientHeight + dialog_remind_confirm_inner_div.style.paddingTop + dialog_remind_confirm_inner_div.style.paddingBottom;
		dialog_remind_confirm_canvas.setAttribute("height", canvasHeight + "px");
		// 设置大背景图片
		draw(dialog_remind_confirm_canvas, dialogmode_contact_bg, dialog_view_bg_coordinates);
		//点击事件
		dialog_remind_confirm_inner_div.addEventListener("touchstart", function(e) {
			var target = e.target;
			target.style.background = "url('" + list_item_background_pressed + "')";
		}, false);
		dialog_remind_confirm_inner_div.addEventListener("touchmove", function(e) {
			var target = e.target;
			target.style.background = "";
		}, false);
		dialog_remind_confirm_inner_div.addEventListener("touchend", function(e) {
			var target = e.target;
			target.style.background = "";
			var id = target.id;
			var length = id.length;
			var index = id.substring(length - 1, length);
			document.body.removeChild(outDiv);
			exec(remindTaskHandler, 'clickItem', [index]);
		}, false);

		currentCanDeleteView = outDiv;
		return outDiv;
	}
	function createRemindConfirmItemView(remindTaskHandler, index, text) {
		var itemDiv = document.createElement("div");
		itemDiv.className = "css_dialog_remind_confirm_item_div";
		itemDiv.id = remindTaskHandler + index;
		itemDiv.innerText = text;

		return itemDiv;
	}
	return createRemindConfirmView;
})